/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.MotivoCancelacionDAO;
import com.rjconsultores.ventaboletos.entidad.MotivoCancelacion;

/**
 *
 * @author Rafius
 */
@Repository("motivoCancelacionDAO")
@SuppressWarnings("unchecked")
public class MotivoCancelacionHibernateDAO extends GenericHibernateDAO<MotivoCancelacion, Integer>
        implements MotivoCancelacionDAO {

    @Autowired
    public MotivoCancelacionHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

	@Override
    public List<MotivoCancelacion> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
        c.addOrder(Order.asc("descmotivo"));

        return c.list();
    }

    public List<MotivoCancelacion> buscar(String descmotivo, String tipomotivo) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
        c.add(Restrictions.eq("descmotivo", descmotivo));
        c.add(Restrictions.eq("tipomotivo", tipomotivo));

        return c.list();
    }

    public List<MotivoCancelacion> obtenerTodosTipoMotivoB() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
        c.add(Restrictions.eq("tipomotivo", "B"));
        c.addOrder(Order.asc("descmotivo"));

        return c.list();
    }

    public List<MotivoCancelacion> obtenerTodosEspecificos(Integer[] motivos) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
        c.add(Restrictions.in("motivocancelacionId", motivos));
        c.addOrder(Order.asc("descmotivo"));

        return c.list();
    }
    
	public MotivoCancelacion findByCveSistema(String cveSistema) {
		StringBuilder sb = new StringBuilder();
		sb.append(" select mc");
		sb.append(" from MotivoCancelacion mc");
		sb.append(" where mc.cveSistema = :cveSistema");
		sb.append(" and mc.activo=1");
		
		Query miQry = getSession().createQuery(sb.toString());
		miQry.setString("cveSistema", cveSistema);
	
		return (MotivoCancelacion) miQry.uniqueResult();
	}
}
